﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Ethernet_data
{
 

    public class AutoConnect
    {
        private Socket UDP;
        private bool _closeing = false;

        public bool Closeing { get => _closeing; set => _closeing = value; }
        private bool resing = false;
        private IPEndPoint iep;
        private UdpClient UDP_send;
        TcpListener m_sockListener=null;

        public delegate void addDeviceHandle(DeviceInfo deviceInfo);
        public event addDeviceHandle AddDeviceEvent;
  

        /// <summary>
        /// The response of the listening device to the broadcast 监听设备对广播的响应
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        public Object read_message(byte[] data)
        {

            UDP = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            UDP.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);
            IPEndPoint iep1 = new IPEndPoint(IPAddress.Any, 65534);
            EndPoint Remote = (EndPoint)(iep1);
            UDP.Bind(Remote);

            iep = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 65533);
            UDP_send = new UdpClient();
            UDP_send.Send(data, data.Length, iep);//发送数据
            UDP_send.Close();
            Object result = listen();
            return result;

        }

        /// <summary>
        /// listen 
        /// </summary>
        /// <returns></returns>
        private Object listen()//监听
        {
            try
            {
                byte[] receive_data = new byte[1024];
                bool result = false;
                int delaytime = 0;
                while (true)
                {
                    Thread.Sleep(100);
                    if (delaytime++ > 20)
                    {
                        return result;
                    }
                    if (UDP != null)
                    {
                        if (UDP.Available > 0)
                        {
                            delaytime = 0;
                            resing = true;
                            UDP.Receive(receive_data);//返回接受的数据 Encoding.UTF8.GetString
                            resing = false;
                            //  if (receive_data.Length != 208) continue;
                            if (receive_data[207] != 13) continue;

                            if (receive_data[1] == 0x10 && receive_data[2] == 0x04)      //获取设备应答
                            {

                               DeviceInfo deviceInfo= GetDeviceInfos(receive_data);
                                if (deviceInfo != null&&AddDeviceEvent!=null)
                                {
                                    AddDeviceEvent(deviceInfo);
                                }
                                delaytime = 0;
                                result = true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x06)      //设置设备IP地址应答
                            {
                                if (receive_data[77] > 0)
                                {

                                    return false;
                                }
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x1F)      //设置设备工作模式应答
                            {
                                if (receive_data[119] == 0)
                                {

                                    return false;
                                }
                                return true;
                            }

                        }
                    }

                }
            }
            finally
            {
                if (UDP != null) UDP.Close();

            }
        }

        /// <summary>
        /// get the deviceInfo form bytes data  从字节数组解析设备信息
        /// </summary>
        /// <param name="receive_data"></param>
        /// <returns></returns>
        private DeviceInfo GetDeviceInfos(byte[] receive_data)
        {
            DeviceInfo deviceInfo = new DeviceInfo();

            string devicename, IP, SubnetMask, Gateway, MAC;
            MAC = receive_data[72] + "-" + receive_data[73] + "-" + receive_data[74] + "-" + receive_data[75] + "-" + receive_data[76] + "-" + receive_data[77];
            IP = receive_data[78] + "." + receive_data[79] + "." + receive_data[80] + "." + receive_data[81];
            SubnetMask = receive_data[82] + "." + receive_data[83] + "." + receive_data[84] + "." + receive_data[85];
            Gateway = receive_data[86] + "." + receive_data[87] + "." + receive_data[88] + "." + receive_data[89];
            byte[] name = new byte[21];
            Array.Copy(receive_data, 90, name, 0, 21);
            devicename = Encoding.Default.GetString(name);
            devicename = devicename.Substring(0, devicename.IndexOf('\0'));
            deviceInfo.IP = IP;
            deviceInfo.MAC = MAC;
            deviceInfo.SubnetMask = SubnetMask;
            deviceInfo.Gateway = Gateway;
            deviceInfo.Devicename = devicename;
            return deviceInfo;
        }

        /// <summary>
        /// get the reader power by deviceIp 根据设备ip获取设备功率
        /// </summary>
        /// <param name="ip"></param>
        /// <param name="port"></param>
        /// <param name="deviceIp"></param>
        /// <param name="deviceCount"></param>
        /// <returns></returns>
        public string GetPower(string ip, string port, string deviceIp, int deviceCount)
        {
            if (m_sockListener != null)
            {
                m_sockListener.Stop();
            }
            try
            {
                IPAddress localAddr = IPAddress.Parse(ip);
                m_sockListener = new TcpListener(localAddr, int.Parse(port));
            }
            catch { }
           
            m_sockListener.ExclusiveAddressUse = false;
            m_sockListener.Start(deviceCount);
            Thread.Sleep(500);
            int delaytime = 30;
            TcpClient tcpclient_tmp = null;
            bool result = false;
            

            while (delaytime-- > 0)
            {
                try
                {
                    if (m_sockListener.Pending())
                    {
                        tcpclient_tmp = m_sockListener.AcceptTcpClient();//侦听到连接后创建客户端连接TcpClient 
                        if (tcpclient_tmp != null)
                        {
                            string iptmp1 = tcpclient_tmp.Client.RemoteEndPoint.ToString();
                            iptmp1 = iptmp1.Substring(0, iptmp1.IndexOf(':'));
                            if (tcpclient_tmp.Connected == true && deviceIp == iptmp1)
                            {

                                string value = getDB_tcpip(tcpclient_tmp);

                                m_sockListener.Stop();
                                return value;
                            }
                            else {
                                tcpclient_tmp.Close();
                            }
                        }

                    }
                }
                catch (Exception ex)
                {
                }

            }
            m_sockListener.Stop();
            return "";
        }

        /// <summary>
        ///  set the reader power by deviceIp 根据设备ip设置设备功率
        /// </summary>
        /// <param name="ip"></param>
        /// <param name="port"></param>
        /// <param name="deviceIp"></param>
        /// <param name="deviceCount"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        public bool SetPower(string ip, string port, string deviceIp, int deviceCount, string value)
        {
            if (m_sockListener != null)
            {
                m_sockListener.Stop();
            }
            try
            {
                IPAddress localAddr = IPAddress.Parse(ip);
                m_sockListener = new TcpListener(localAddr, int.Parse(port));
            }
            catch { }
            
            m_sockListener.ExclusiveAddressUse = false;
            m_sockListener.Start(deviceCount);
            Thread.Sleep(500);
            int delaytime = 30;
            TcpClient tcpclient_tmp = null;
            bool result = false;


            while (delaytime-- > 0)
            {
                try
                {
                    if (m_sockListener.Pending())
                    {
                        tcpclient_tmp = m_sockListener.AcceptTcpClient();//侦听到连接后创建客户端连接TcpClient 
                        if (tcpclient_tmp != null)
                        {
                            string iptmp1 = tcpclient_tmp.Client.RemoteEndPoint.ToString();
                            iptmp1 = iptmp1.Substring(0, iptmp1.IndexOf(':'));
                            if (tcpclient_tmp.Connected == true && deviceIp == iptmp1)
                            {
                            
                                bool isok= setDB_tcpip(tcpclient_tmp, value);
                                tcpclient_tmp.Close();
                                m_sockListener.Stop();
                                 
                                return isok;
                            }
                        }

                    }
                }
                catch (Exception ex)
                {
                }

            }
            m_sockListener.Stop();
            return false;
        }

        /// <summary>
        /// get the reader power 读取功率
        /// </summary>
        /// <param name="tcpclient"></param>
        /// <returns></returns>
        private string getDB_tcpip(TcpClient tcpclient)
        {
            byte Addr = ReadAddr(tcpclient);
            if (Addr == 0) return "";


            byte[] sendBuf = new byte[] { Addr, 0x04, 0x4c, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return "";
            }

            for (int i = 0; i < 20; i++)
            {
                int count = tcpclient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            byte btDB = recvBuf[3];
                           string value = (31 - btDB).ToString();

                            //addinfo("Get Power sucessfully!", false);
                            return value;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            //addinfo("Get Power failed", true);
            return "";
        }

        /// <summary>
        /// set the reader power 设置功率
        /// </summary>
        /// <param name="tcpclient"></param>
        /// <param name="value"></param>
        /// <returns></returns>
        private bool setDB_tcpip(TcpClient tcpclient,string value)
        {
            byte Addr = ReadAddr(tcpclient);
            if (Addr == 0) return false;

            byte btDB = 0;

            try
            {
                btDB = byte.Parse(value);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return false;
            }
            if (btDB > 31) btDB = 31;
            btDB = (byte)(31 - btDB);

            byte[] sendBuf = new byte[] { Addr, 0x05, 0xcc, btDB, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return false;
            }

            for (int i = 0; i < 20; i++)
            {
                int count = tcpclient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == btDB && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            //addinfo("Set Power sucessfully!", false);
                            return true;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            //addinfo("Set Power failed", true);
            return false;
        }

        /// <summary>
        /// get the reader id 获取读卡器id
        /// </summary>
        /// <param name="tcpclient"></param>
        /// <returns></returns>
        private byte ReadAddr(TcpClient tcpclient)
        {
            byte addr = 0;

            byte[] sendBuf = new byte[] { 0xff, 0xff, 0x08, 0xee, 0xee };
            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, 5);
            }
            catch (Exception exp)
            {
                //addinfo(exp.Message, true);
                return 0;
            }

            for (int i = 0; i < 20; i++)
            {
                int count = tcpclient.Available;

                if (count >= 5)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 5 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == 0xEE && recvBuf[4] == 0xEE)
                        {
                            addr = recvBuf[2];
                            break;
                        }
                    }
                    catch (Exception exp)
                    {
                        //addinfo(exp.Message, true);
                        return 0;
                    }
                }
                Thread.Sleep(50);
            }
            return addr;
        }
 
    }
}
