﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using RFIDLib;

namespace Ethernet_data
{
    public partial class frmmain : Form
    {
        const int _readerip = 0, _SubnetMask = 1, _Gateway = 2, _MAC = 3, _devicename = 4, _power = 5, _state = 6;

        private const string scanreader = "Searching Reader";
        private const string scanreader_ok = "Successful connection   ";
        private const string scanreader_fail = "Auto Connect failed, please check:1. If your PC and RFID reader are in the same network?2. If your PC is a laptop? " +
            "Due to the laptop has 2 NIC(network interface card), it is required to disable one to make sure the AUTO Connect is valid." +
            "3. Please make sure the system firewall is turned off or the RFID application is whitelisted.";
        private const string ip_fail ="Different network segments, or address conflicts, setting"; //"网段不同或地址冲突，正在设置";
        private const string set_ok = "Set DL9230 Reader IP success";
        private const string set_fail ="Failed to set the IP"; // "设置IP失败";
        private const string start_read = "Start reading Tag";
        private const string stop_read = "Stop Reading Tag";
        private const string nofindreader = "Connection Failed";
        private const string setip_fail = "Set the IP address failed  ";
        private const string setWordMode_fail ="Failed to set the working mode    "; // "设置工作模式失败     ";
        private const string getlocalfail ="Failed to get the PC client IP address";  // "没能获取电脑端IP地址";
        RFIDReader m_rfidReader =RFIDReaderFactory.GetRfidReader("TcpReader_5");

        #region  TCPIP  用到的变量

        TcpListener m_sockListener = null;
        public TcpClient[] m_tcpClient = new TcpClient[0];
        TcpClient currtcpclient = null;
        AutoConnect _autoConnect = new AutoConnect();

        private IPEndPoint iep;
        private bool Closeing = false;
        private bool  resing=false ;
        private byte[] receive_data = new byte[1024];
        private string[] ComputerIP = new string[3];
        string[,] network_info = new string[10,4];
        //private RFIDLib.TcpReader_5 tcp_reader = new RFIDLib.TcpReader_5();
        #endregion

        ///*************************************************************************/
        //public struct TAGDATA
        //{
        //    public byte addr;     //读卡器地址
        //    public byte volt;     //标签电压 0：正常，1：欠压
        //    public uint tagID;    //卡号
        //    public DateTime time; //时间
        //}
        //List<TAGDATA> listTag;
        /*************************************************************************/

        public frmmain()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
            this.WindowState = FormWindowState.Maximized;
        }
     

        //***************************************************************************************************************
        #region 其它事件

        private void Form3_Load(object sender, EventArgs e)
        {
            this.Text = Application.ProductName + "  V" + Application.ProductVersion;
            dataGridView1.RowCount = 0;
            dataGridView1.Columns[2].DefaultCellStyle.ForeColor = Color.Blue;

            comboBox_port.Text = "10000";

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            for (int i = 0; i < network_count; i++)
            {
                comboBox_ip.Items.Add(network_info[i, 0]);
            }
            if (comboBox_ip.Items.Count == 1) comboBox_ip.SelectedIndex=0;
        }
        private void frmmain_Shown(object sender, EventArgs e)
        {
            //getreaderip_Click(null, null);
        }
        private void frmmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (resing)
            {
                Application.DoEvents();
            }
            Closeing = true;
            //tcp_reader.Stop();
            foreach (TcpClient item in m_tcpClient)
            {
                if (item != null)
                {
                    if(item .Connected) item.Close();
                }
            }
        }
        private void addinfo(string infoname, bool iserror)
        {
            for (int row = 0; row < dataGridView2.RowCount; row++)
            {
                if ( dataGridView2[1, row].Value.ToString().Contains(infoname))
                {
                    dataGridView2.Rows.RemoveAt(row);
                }
            }
                    string[] info = new string[2];
            info[0] = (dataGridView2.RowCount + 1).ToString();
            info[1] = DateTime.Now.ToLongTimeString() + "  " + infoname;
            dataGridView2.Rows.Add(info);
            dataGridView2[0,dataGridView2.RowCount - 1].Selected = true;
            if (iserror) dataGridView2.Rows[dataGridView2.RowCount - 1].DefaultCellStyle.ForeColor = Color.Red;
            dataGridView2.FirstDisplayedScrollingRowIndex = dataGridView2.RowCount - 1;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView2.RowCount = 0;
        }
        private void comboBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789.\b".IndexOf(e.KeyChar) < 0;
        }
        private void comboBox_port_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789\b".IndexOf(e.KeyChar) < 0;
        }

        private void Clearbtn_Click(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            label7.Text = "0";
        }
        private void tag_show(string ip,string addr,string tagID,bool isOverpressure, string time)
        {
            bool findok = false;
            string isOverpressureStr = "Nomal";
            if (isOverpressure)
            {
                isOverpressureStr = "Undervoltage";
            }
            for (int row =0; row < dataGridView1.RowCount; row++)
            {
                if (tagID == dataGridView1[3, row].Value.ToString() && ip == dataGridView1[1, row].Value.ToString())
                {
                    if (isOverpressure)
                    {
                        dataGridView1.Rows[row].Cells[4].Style.ForeColor = Color.Red;

                    }
                    else {
                        dataGridView1.Rows[row].Cells[4].Style.ForeColor = Color.Black;
                    }
                    dataGridView1[4, row].Value = isOverpressureStr;
                    dataGridView1[5, row].Value = time;
                    dataGridView1[6, row].Value = (int.Parse(dataGridView1[6, row].Value.ToString()) + 1).ToString();
                    //dataGridView1[4, row].Selected=true;
                    findok = true;
                    break;
                }

            }
            if (!findok)
            {
                string[] str1 = new string[7];
                str1[0] = (dataGridView1.RowCount + 1).ToString();
                str1[1] = ip;
                str1[2] = addr;
                str1[3] = tagID;
                str1[4] = isOverpressureStr;
                str1[5] = time;
                str1[6] = "1";
                dataGridView1.Rows.Add(str1);
                dataGridView1.FirstDisplayedScrollingRowIndex = dataGridView1.RowCount - 1;
            }
            label7.Text = dataGridView1.RowCount.ToString();
        }

        #endregion

        #region  reader connect 连接相关函数或事件

        private void autoconnect_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                panel1.Enabled = false;
                ListView1.Items.Clear();
                addinfo(scanreader, false);
                if (searchReader())
                {
                    comboBox_ip.Text = ComputerIP[0];
                    comboBox_port.Text  = "10000";
                    getTagbtn_Click(null, null);
                }
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }
        private void M_rfidReader_OnLineNotify(byte devID, object data)
        {

        }
        private void getTagbtn_Click(object sender, EventArgs e)
        {
            
            if (comboBox_ip.Text.Trim() == "" || comboBox_port.Text.Trim() == null)
            {
                comboBox_ip.Focus();
                MessageBox.Show("ip或端口不能为空！");
                return;
            }

            if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
            {
                try
                {
                    foreach (TcpClient item in m_tcpClient)
                    {
                        if (item != null)
                        {
                            try
                            {
                                if (item.Connected) item.Close();
                            }
                            catch { }
                        }
                    }

                    //开始读卡
                    m_rfidReader.Start(comboBox_ip.Text + "," + comboBox_port.Text);

                    //m_rfidReader.OnLineNotify += M_rfidReader_OnLineNotify;

                    timer1.Interval = 500;
                    timer1.Enabled = true;//启动定时器，以便定时获取读卡器数据
                  

                    getTagbtn.Text = "Stop";
                    getTagbtn.Tag = "1";
                    autoconnect.Enabled = panel2.Enabled = false;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "提示");
                    return;
                }

            }
            else
            {
                timer1.Enabled = false;
                m_rfidReader.Stop();
                getTagbtn.Text = "Start";
                getTagbtn.Tag = "";
                panel2.Enabled = autoconnect.Enabled = true;
                panel1.Enabled = true;
            }

            //if (getTagbtn.Enabled == false) return;
            //if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
            //{
            //    if (comboBox_ip.Text.Trim() == "")
            //    {
            //        comboBox_ip.Focus();
            //        return;
            //    }
            //    getTagbtn.Enabled = autoconnect.Enabled = panel2.Enabled = false;
            //    dataGridView1.Rows.Clear();
            //    if (Tcpip_connect(comboBox_ip.Text, comboBox_port.Text))
            //    {
            //        timer1.Enabled = true;
            //        addinfo(start_read, false);
            //        getTagbtn.Text = "Stop";
            //        getTagbtn.Tag = "1";
            //    }
            //    else
            //    {
            //        panel2.Enabled = autoconnect.Enabled = true;

            //    }
            //    getTagbtn.Enabled = true;
            //}
            //else
            //{
            //    timer1.Enabled = false;
            //    addinfo(stop_read, false);
            //    panel2.Enabled = autoconnect.Enabled = true;
            //    getTagbtn.Text ="Start";
            //    getTagbtn.Tag =  "";
            //}
        }

     
        /// <summary>
        /// Search reader and setting
        /// </summary>
        /// <param name="IP"> computer ip </param>
        /// <returns></returns>
        private bool searchReader()
        {
            panel1.Enabled = false;
            ListView1.Items.Clear();

            int docount = 0;
            bool result = false;
            byte[] data = reader.GetReader_list();
            _autoConnect.AddDeviceEvent += _autoConnect_AddDeviceEvent;
            while (docount++ < 2)
            {
                try
                {
                    result = (bool)_autoConnect.read_message(data);
                    _autoConnect.AddDeviceEvent -= _autoConnect_AddDeviceEvent;
                }
                catch (Exception ex) {
                    MessageBox.Show(ex.Message, nofindreader, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                if (result) break;
            }
            if (result == false)
            {
                addinfo(scanreader_fail,false);
                //MessageBox.Show(, nofindreader, MessageBoxButtons.OK, MessageBoxIcon.Error);
                //addinfo(scanreader_fail, true);
                return false;
            }

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            if (network_count == 0)  //没有网卡
            {
                addinfo(getlocalfail, true);
                return false;
            }
            else if (network_count == 1)  //只有一张网卡
            {
                int index = 0;
                ComputerIP[0] = network_info[index, 0];
                ComputerIP[1] = network_info[index, 1];
                ComputerIP[2] = network_info[index, 2];
            }
            else //有多张网卡
            {

                Form3 frm = new Form3();
                DataGridView grid1 = frm.grid1;
                for (int i = 0; i < network_count; i++)
                {
                    grid1.Rows.Add(); ;
                    grid1[0, grid1.Rows.Count - 1].Value = network_info[i, 3];
                    grid1[1, grid1.Rows.Count - 1].Value = network_info[i, 0];
                    grid1[2, grid1.Rows.Count - 1].Value = network_info[i, 1];
                    grid1[3, grid1.Rows.Count - 1].Value = network_info[i, 2];
                }
                if (frm.ShowDialog(this) != DialogResult.OK)
                {
                    return false;
                }
                ComputerIP[0] = grid1[1, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[1] = grid1[2, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[2] = grid1[3, grid1.SelectedRows[0].Index].Value.ToString();
            }
           
            bool IPsame = false;
            foreach (ListViewItem item in ListView1.Items)
            {
                string[] tmp1 = item.Text.Split('.');
                string[] localtion = ComputerIP[0].Split('.');
                IPsame = false;
                for (int i = 0; i < item.Index; i++)
                {
                    if (item.SubItems[_readerip].Text == ListView1.Items[i].SubItems[_readerip].Text)
                    {
                        IPsame = true;
                        break;
                    }
                }
                if (IPsame||item.SubItems[_SubnetMask].Text != ComputerIP[1] || item.SubItems[_Gateway].Text != ComputerIP[2] || tmp1[0] != localtion[0] || tmp1[1] != localtion[1] || tmp1[2] != localtion[2] || item.SubItems[_readerip].Text == ComputerIP[0]) //网段不同或掩码不同或网关不同
                {
                    addinfo(ip_fail, true);

                    string newip = Class3.ScanTarget(localtion[0] + "." + localtion[1] + "." + localtion[2]); //获取局域网一个空闲IP
                    if (string.IsNullOrEmpty(newip)) return false;

                    data = reader.SETReader(newip, ComputerIP[1], ComputerIP[2],item .SubItems[_MAC].Text); //设置reader IP
                    try
                    {
                        if ((bool)_autoConnect.read_message(data))
                        {
                            ListView1.Items[item.Index].SubItems[_readerip].Text = newip;
                            ListView1.Items[item.Index].SubItems[_SubnetMask].Text = ComputerIP[1];
                            ListView1.Items[item.Index].SubItems[_Gateway].Text = ComputerIP[2];
                            addinfo(set_ok, false);
                        }
                        else
                        {

                            addinfo(set_fail, true);
                            return false;
                        }
                    }
                    catch (Exception ex) {
                        MessageBox.Show(ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                data = reader.Set_WorkMode(ComputerIP[0],item.SubItems[_MAC].Text); //设置工作模式
                if (!(bool)_autoConnect.read_message(data))
                {
                    
                    return false;
                }
            }
            return true;
        }

        private void _autoConnect_AddDeviceEvent(DeviceInfo deviceInfo)
        {
            ShowDeviceList(deviceInfo);
        }

        private void ShowDeviceList(DeviceInfo deviceInfo)
        {
            string[] str = new string[ListView1.Columns.Count];
            str[0] = deviceInfo.IP;
            str[1] = deviceInfo.SubnetMask;
            str[2] = deviceInfo.Gateway;
            str[3] = deviceInfo.MAC;
            str[4] = deviceInfo.Devicename;
            for (int i = 5; i < ListView1.Columns.Count; i++)
            {
                str[i] = "";
            }
            ListViewItem item = new ListViewItem(str);
            item.Checked = true;
            item.ImageIndex = 0;
           
            ListView1.Items.Add(item);
            btnItemGetDB_Click(null,null);
            changeConnectState(item.Index, "connected");
        }
        
        private void changeConnectState(int row,string value)
        {
            if (row >= 0)
            {
                ListView1.Items[row].SubItems[_state].Text = value;
                ListView1.Items[row].ForeColor = value == "" ? Color.DimGray : Color.Blue;
            }
            else
            {
                for (row = 0; row < ListView1.Items.Count; row++)
                {
                    ListView1.Items[row].SubItems[_state].Text = value;
                    ListView1.Items[row].ForeColor = value == "" ? Color.DimGray : Color.Blue;
                }
            }
        }
        
        /***************************************************TCPIP connect END***************************************************************************/
        #endregion

        #region read tag 获取标签相关事件或函数


        
        private void timer1_Tick(object sender, EventArgs e)
        {
            //读取读卡器中标签数据
            List<TAGDATA> listTag = m_rfidReader.GetTagData();

            if (listTag == null || listTag.Count == 0)
            {
                addinfo("can not get tag data,please check the reader is ready and have a valid rfidCare ",false);
                return;
            }
            for (int i = 0; i < listTag.Count; i++)
            {
                if (ListView1.Items != null && ListView1.Items.Count > 0)
                {
                    ListViewItem item = ListView1.FindItemWithText(listTag[i].strReaderIP, false, 0);
                    if (item != null)
                    {
                        if (item.Checked) //选择了
                        {
                            tag_show(listTag[i].strReaderIP, listTag[i].readerID.ToString(), listTag[i].tagID.ToString(), listTag[i].bVoltLow, listTag[i].time.ToString("yyyy-MM-dd HH:mm;ss"));

                        }
                    }
                }
                else
                {
                    tag_show(listTag[i].strReaderIP, listTag[i].readerID.ToString(), listTag[i].tagID.ToString(), listTag[i].bVoltLow, listTag[i].time.ToString("yyyy-MM-dd HH:mm;ss"));
                }

            }
 
        }

        private void ListView1_SizeChanged(object sender, EventArgs e)
        {
            int _Count = ListView1.Columns.Count;
            int _Width = ListView1.Width;
            foreach (ColumnHeader ch in ListView1.Columns)
            {
                ch.Width = _Width / _Count;
            }
 
        }

        #endregion

        #region    衰减值读取与设置

        //读取衰减值
        private void btnItemGetDB_Click(object sender, EventArgs e)
        {
       
            textBoxReaderDB.Text = "";
            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked == false) continue;
                string iptmp1 = item.SubItems[_readerip].Text;
                string power= _autoConnect. GetPower(comboBox_ip.Text,comboBox_port.Text,  iptmp1, ListView1.Items.Count);
                ListView1.Items[item.Index].SubItems[_power].Text = power;
                
               
            }
        }
         //设置衰减值
        private void btnItemSetDB_Click(object sender, EventArgs e)
        {
            if (textBoxReaderDB.Text.Trim() == "")
            {
                textBoxReaderDB.Focus();
                return;
            }

            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked == false) continue;
                string iptmp1 = item.SubItems[_readerip].Text;
                string value= textBoxReaderDB.Text;

                bool isok = _autoConnect.SetPower(comboBox_ip.Text, comboBox_port.Text, iptmp1, ListView1.Items.Count, value);
                if (isok) {
                    ListView1.Items[item.Index].SubItems[_power].Text= textBoxReaderDB.Text;
                }
              
               
            }
        }

         
        
        #endregion

        private void gridreader_ItemChecked(object sender, ItemCheckedEventArgs e)
        {
            panel2.Enabled =  false;
            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked)
                {
                    panel2.Enabled = getTagbtn.Enabled = true;
                    break;
                }
            }
        }

        private void gridreader_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if(ListView1 .SelectedItems.Count==0) return ;
                System.Diagnostics.Process.Start("http://" + ListView1.SelectedItems[0].SubItems[_readerip].Text);
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            ListView1.View = View.LargeIcon;
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            ListView1.View = View.Details;
        }
    }
}